diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/examples/mesh.cc ns-3.36/src/mesh/examples/mesh.cc
--- ns-3.35/src/mesh/examples/mesh.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/examples/mesh.cc	2022-04-30 18:23:58.066734600 -0700
@@ -39,6 +39,33 @@
  *  * --- * --- *                _
  *  ^ Ping source
  *
+ * By varying m_xSize and m_ySize, one can configure the route that is used.
+ * When the inter-nodal distance is small, the source can reach the sink
+ * directly.  When the inter-nodal distance is intermediate, the route
+ * selected is diagonal (two hop).  When the inter-nodal distance is a bit
+ * larger, the diagonals cannot be used and a four-hop route is selected.
+ * When the distance is a bit larger, the packets will fail to reach even the
+ * adjacent nodes.
+ *
+ * As of ns-3.36 release, with default configuration (mesh uses Wi-Fi 802.11a
+ * standard and the ArfWifiManager rate control by default), the maximum
+ * range is roughly 50m.  The default step size in this program is set to 50m,
+ * so any mesh packets in the above diagram depiction will not be received
+ * successfully on the diagonal hops between two nodes but only on the
+ * horizontal and vertical hops.  If the step size is reduced to 35m, then
+ * the shortest path will be on the diagonal hops.  If the step size is reduced
+ * to 17m or less, then the source will be able to reach the sink directly
+ * without any mesh hops (for the default 3x3 mesh depicted above). 
+ *
+ * The position allocator will lay out the nodes in the following order
+ * (corresponding to Node ID and to the diagram above):
+ *
+ * 6 - 7 - 8
+ * |   |   | 
+ * 3 - 4 - 5
+ * |   |   | 
+ * 0 - 1 - 2
+ *
  *  See also MeshTest::Configure to read more about configurable
  *  parameters.
  */
@@ -57,7 +84,26 @@
 
 using namespace ns3;
 
-NS_LOG_COMPONENT_DEFINE ("TestMeshScript");
+NS_LOG_COMPONENT_DEFINE ("MeshExample");
+
+// Declaring these variables outside of main() for use in trace sinks
+uint32_t g_udpTxCount = 0;
+uint32_t g_udpRxCount = 0;
+
+void
+TxTrace (Ptr<const Packet> p)
+{
+  NS_LOG_DEBUG ("Sent " << p->GetSize () << " bytes");  
+  g_udpTxCount++;
+}
+
+void
+RxTrace (Ptr<const Packet> p)
+{
+  NS_LOG_DEBUG ("Received " << p->GetSize () << " bytes");  
+  g_udpRxCount++;
+}
+
 
 /**
  * \ingroup mesh
@@ -115,10 +161,10 @@
 MeshTest::MeshTest () :
   m_xSize (3),
   m_ySize (3),
-  m_step (100.0),
+  m_step (50.0),
   m_randomStart (0.1),
   m_totalTime (100.0),
-  m_packetInterval (0.1),
+  m_packetInterval (1),
   m_packetSize (1024),
   m_nIfaces (1),
   m_chan (true),
@@ -195,6 +241,8 @@
   mesh.SetNumberOfInterfaces (m_nIfaces);
   // Install protocols and return container if MeshPointDevices
   meshDevices = mesh.Install (wifiPhy, nodes);
+  // AssignStreams can optionally be used to control random variable streams
+  mesh.AssignStreams (meshDevices, 0);
   // Setup mobility - static grid topology
   MobilityHelper mobility;
   mobility.SetPositionAllocator ("ns3::GridPositionAllocator",
@@ -207,7 +255,7 @@
   mobility.SetMobilityModel ("ns3::ConstantPositionMobilityModel");
   mobility.Install (nodes);
   if (m_pcap)
-    wifiPhy.EnablePcapAll (std::string ("mp-"));
+    wifiPhy.EnablePcapAll (std::string ("mp"));
   if (m_ascii)
     {
       AsciiTraceHelper ascii;
@@ -226,17 +274,22 @@
 void
 MeshTest::InstallApplication ()
 {
-  UdpEchoServerHelper echoServer (9);
-  ApplicationContainer serverApps = echoServer.Install (nodes.Get (0));
-  serverApps.Start (Seconds (0.0));
-  serverApps.Stop (Seconds (m_totalTime));
-  UdpEchoClientHelper echoClient (interfaces.GetAddress (0), 9);
+  uint16_t portNumber = 9;
+  UdpEchoServerHelper echoServer (portNumber);
+  uint16_t sinkNodeId = m_xSize * m_ySize - 1;
+  ApplicationContainer serverApps = echoServer.Install (nodes.Get (sinkNodeId));
+  serverApps.Start (Seconds (1.0));
+  serverApps.Stop (Seconds (m_totalTime + 1));
+  UdpEchoClientHelper echoClient (interfaces.GetAddress (sinkNodeId), portNumber);
   echoClient.SetAttribute ("MaxPackets", UintegerValue ((uint32_t)(m_totalTime*(1/m_packetInterval))));
   echoClient.SetAttribute ("Interval", TimeValue (Seconds (m_packetInterval)));
   echoClient.SetAttribute ("PacketSize", UintegerValue (m_packetSize));
-  ApplicationContainer clientApps = echoClient.Install (nodes.Get (m_xSize*m_ySize-1));
-  clientApps.Start (Seconds (0.0));
-  clientApps.Stop (Seconds (m_totalTime));
+  ApplicationContainer clientApps = echoClient.Install (nodes.Get (0));
+  Ptr<UdpEchoClient> app = clientApps.Get (0)->GetObject<UdpEchoClient> ();
+  app->TraceConnectWithoutContext ("Tx", MakeCallback (&TxTrace));
+  app->TraceConnectWithoutContext ("Rx", MakeCallback (&RxTrace));
+  clientApps.Start (Seconds (1.0));
+  clientApps.Stop (Seconds (m_totalTime + 1.5));
 }
 int
 MeshTest::Run ()
@@ -245,9 +298,10 @@
   InstallInternetStack ();
   InstallApplication ();
   Simulator::Schedule (Seconds (m_totalTime), &MeshTest::Report, this);
-  Simulator::Stop (Seconds (m_totalTime));
+  Simulator::Stop (Seconds (m_totalTime + 2));
   Simulator::Run ();
   Simulator::Destroy ();
+  std::cout << "UDP echo packets sent: " << g_udpTxCount << " received: " << g_udpRxCount << std::endl;
   return 0;
 }
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/helper/mesh-helper.cc ns-3.36/src/mesh/helper/mesh-helper.cc
--- ns-3.35/src/mesh/helper/mesh-helper.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/helper/mesh-helper.cc	2022-04-30 18:23:58.070734500 -0700
@@ -179,14 +179,10 @@
 {
   Ptr<WifiNetDevice> device = CreateObject<WifiNetDevice> ();
 
-  auto it = wifiStandards.find (m_standard);
-  if (it == wifiStandards.end ())
-    {
-      NS_FATAL_ERROR ("Selected standard is not defined!");
-      return device;
-    }
-
-  Ptr<MeshWifiInterfaceMac> mac = m_mac.Create<MeshWifiInterfaceMac> ();
+  // this is a const method, but we need to force the correct QoS setting
+  ObjectFactory macObjectFactory = m_mac;
+  macObjectFactory.Set ("QosSupported", BooleanValue (true));  // a mesh station is a QoS station
+  Ptr<MeshWifiInterfaceMac> mac = macObjectFactory.Create<MeshWifiInterfaceMac> ();
   NS_ASSERT (mac != 0);
   mac->SetSsid (Ssid ());
   mac->SetDevice (device);
@@ -195,19 +191,18 @@
   Ptr<WifiPhy> phy = phyHelper.Create (node, device);
   mac->SetAddress (Mac48Address::Allocate ());
   mac->ConfigureStandard (m_standard);
-  Ptr<RegularWifiMac> wifiMac = DynamicCast<RegularWifiMac> (mac);
-  Ptr<FrameExchangeManager> fem;
-  if (wifiMac != 0 && (fem = wifiMac->GetFrameExchangeManager ()) != 0)
+  Ptr<FrameExchangeManager> fem = mac->GetFrameExchangeManager ();
+  if (fem != nullptr)
     {
       Ptr<WifiProtectionManager> protectionManager = CreateObject<WifiDefaultProtectionManager> ();
-      protectionManager->SetWifiMac (wifiMac);
+      protectionManager->SetWifiMac (mac);
       fem->SetProtectionManager (protectionManager);
 
       Ptr<WifiAckManager> ackManager = CreateObject<WifiDefaultAckManager> ();
-      ackManager->SetWifiMac (wifiMac);
+      ackManager->SetWifiMac (mac);
       fem->SetAckManager (ackManager);
     }
-  phy->ConfigureStandardAndBand (it->second.phyStandard, it->second.phyBand);
+  phy->ConfigureStandard (m_standard);
   device->SetMac (mac);
   device->SetPhy (phy);
   device->SetRemoteStationManager (manager);
@@ -249,6 +244,7 @@
       Ptr<MeshWifiInterfaceMac> mac;
       if (mpd)
         {
+          currentStream += mpd->AssignStreams (currentStream);
           // To access, we need the underlying WifiNetDevices
           std::vector<Ptr<NetDevice> > ifaces = mpd->GetInterfaces ();
           for (std::vector<Ptr<NetDevice> >::iterator i = ifaces.begin (); i != ifaces.end (); i++)
@@ -267,39 +263,54 @@
                 }
               // Handle any random numbers in the mesh mac and plugins
               mac = DynamicCast<MeshWifiInterfaceMac> (wifi->GetMac ());
-              if (mac)
-                {
-                  currentStream += mac->AssignStreams (currentStream);
-                }
-              Ptr<RegularWifiMac> rmac = DynamicCast<RegularWifiMac> (mac);
-              if (rmac)
-                {
-                  PointerValue ptr;
-                  rmac->GetAttribute ("Txop", ptr);
-                  Ptr<Txop> txop = ptr.Get<Txop> ();
-                  currentStream += txop->AssignStreams (currentStream);
-
-                  rmac->GetAttribute ("VO_Txop", ptr);
-                  Ptr<QosTxop> vo_txop = ptr.Get<QosTxop> ();
-                  currentStream += vo_txop->AssignStreams (currentStream);
-
-                  rmac->GetAttribute ("VI_Txop", ptr);
-                  Ptr<QosTxop> vi_txop = ptr.Get<QosTxop> ();
-                  currentStream += vi_txop->AssignStreams (currentStream);
-
-                  rmac->GetAttribute ("BE_Txop", ptr);
-                  Ptr<QosTxop> be_txop = ptr.Get<QosTxop> ();
-                  currentStream += be_txop->AssignStreams (currentStream);
-
-                  rmac->GetAttribute ("BK_Txop", ptr);
-                  Ptr<QosTxop> bk_txop = ptr.Get<QosTxop> ();
-                  currentStream += bk_txop->AssignStreams (currentStream);
-               }
+              currentStream += mac->AssignStreams (currentStream);
+
+              PointerValue ptr;
+              mac->GetAttribute ("Txop", ptr);
+              Ptr<Txop> txop = ptr.Get<Txop> ();
+              currentStream += txop->AssignStreams (currentStream);
+
+              mac->GetAttribute ("VO_Txop", ptr);
+              Ptr<QosTxop> vo_txop = ptr.Get<QosTxop> ();
+              currentStream += vo_txop->AssignStreams (currentStream);
+
+              mac->GetAttribute ("VI_Txop", ptr);
+              Ptr<QosTxop> vi_txop = ptr.Get<QosTxop> ();
+              currentStream += vi_txop->AssignStreams (currentStream);
+
+              mac->GetAttribute ("BE_Txop", ptr);
+              Ptr<QosTxop> be_txop = ptr.Get<QosTxop> ();
+              currentStream += be_txop->AssignStreams (currentStream);
+
+              mac->GetAttribute ("BK_Txop", ptr);
+              Ptr<QosTxop> bk_txop = ptr.Get<QosTxop> ();
+              currentStream += bk_txop->AssignStreams (currentStream);
             }
         }
     }
   return (currentStream - stream);
 }
 
+void
+MeshHelper::EnableLogComponents (void)
+{
+  WifiHelper::EnableLogComponents ();
+
+  LogComponentEnable ("MeshL2RoutingProtocol", LOG_LEVEL_ALL);
+  LogComponentEnable ("MeshPointDevice", LOG_LEVEL_ALL);
+  LogComponentEnable ("MeshWifiInterfaceMac", LOG_LEVEL_ALL);
+
+  LogComponentEnable ("Dot11sPeerManagementProtocol", LOG_LEVEL_ALL);
+  LogComponentEnable ("HwmpProtocol", LOG_LEVEL_ALL);
+  LogComponentEnable ("HwmpProtocolMac", LOG_LEVEL_ALL);
+  LogComponentEnable ("HwmpRtable", LOG_LEVEL_ALL);
+  LogComponentEnable ("PeerManagementProtocol", LOG_LEVEL_ALL);
+  LogComponentEnable ("PeerManagementProtocolMac", LOG_LEVEL_ALL);
+
+  LogComponentEnable ("FlameProtocol", LOG_LEVEL_ALL);
+  LogComponentEnable ("FlameProtocolMac", LOG_LEVEL_ALL);
+  LogComponentEnable ("FlameRtable", LOG_LEVEL_ALL);
+}
+
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/helper/mesh-helper.h ns-3.36/src/mesh/helper/mesh-helper.h
--- ns-3.35/src/mesh/helper/mesh-helper.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/helper/mesh-helper.h	2022-04-30 18:23:58.070734500 -0700
@@ -216,6 +216,11 @@
    */
   int64_t AssignStreams (NetDeviceContainer c, int64_t stream);
 
+  /**
+   * Helper to enable all MeshPointDevice log components with one statement
+   */
+  static void EnableLogComponents (void);
+
 private:
   /**
    * \param phyHelper
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/model/dot11s/airtime-metric.h ns-3.36/src/mesh/model/dot11s/airtime-metric.h
--- ns-3.35/src/mesh/model/dot11s/airtime-metric.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/model/dot11s/airtime-metric.h	2022-04-30 18:23:58.070734500 -0700
@@ -20,7 +20,10 @@
 
 #ifndef AIRTIME_METRIC_H
 #define AIRTIME_METRIC_H
+
 #include "ns3/mesh-wifi-interface-mac.h"
+#include "ns3/wifi-mac-header.h"
+
 namespace ns3 {
 namespace dot11s {
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/model/dot11s/hwmp-protocol.cc ns-3.36/src/mesh/model/dot11s/hwmp-protocol.cc
--- ns-3.35/src/mesh/model/dot11s/hwmp-protocol.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/model/dot11s/hwmp-protocol.cc	2022-04-30 18:23:58.070734500 -0700
@@ -25,6 +25,9 @@
 #include "ns3/log.h"
 #include "ns3/simulator.h"
 #include "ns3/packet.h"
+#include "ns3/random-variable-stream.h"
+#include "ns3/string.h"
+#include "ns3/pointer.h"
 #include "ns3/mesh-point-device.h"
 #include "ns3/wifi-net-device.h"
 #include "ns3/mesh-wifi-interface-mac.h"
@@ -274,6 +277,7 @@
       tag.DecrementTtl ();
       if (tag.GetTtl () == 0)
         {
+          NS_LOG_DEBUG ("Dropping frame due to TTL expiry");
           m_stats.droppedTtl++;
           return false;
         }
@@ -310,6 +314,7 @@
               Mac48Address address = *i;
               tag.SetAddress (address);
               packetCopy->AddPacketTag (tag);
+              NS_LOG_DEBUG ("Sending route reply for broadcast; address " << address);
               routeReply (true, packetCopy, source, destination, protocolType, plugin->first);
             }
         }
@@ -607,7 +612,9 @@
   NS_LOG_DEBUG ("I am " << GetAddress () << "retransmitting PREQ:" << preq);
   for (HwmpProtocolMacMap::const_iterator i = m_interfaces.begin (); i != m_interfaces.end (); i++)
     {
-      i->second->SendPreq (preq);
+      Time forwardingDelay = GetMeshPoint ()->GetForwardingDelay ();
+      NS_LOG_DEBUG ("Forwarding PREQ from " << from << " with delay " << forwardingDelay.As (Time::US));
+      Simulator::Schedule (forwardingDelay, &HwmpProtocolMac::SendPreq, i->second, preq);
     }
 }
 void
@@ -708,7 +715,9 @@
   //Forward PREP
   HwmpProtocolMacMap::const_iterator prep_sender = m_interfaces.find (result.ifIndex);
   NS_ASSERT (prep_sender != m_interfaces.end ());
-  prep_sender->second->SendPrep (prep, result.retransmitter);
+  Time forwardingDelay = GetMeshPoint ()->GetForwardingDelay ();
+  NS_LOG_DEBUG ("Forwarding PREP from " << from << " with delay " << forwardingDelay.As (Time::US));
+  Simulator::Schedule (forwardingDelay, &HwmpProtocolMac::SendPrep, prep_sender->second, prep, result.retransmitter);
 }
 void
 HwmpProtocol::ReceivePerr (std::vector<FailedDestination> destinations, Mac48Address from, uint32_t interface, Mac48Address fromMp)
@@ -817,6 +826,7 @@
   NS_LOG_FUNCTION (this << seqno << source);
   if (source == GetAddress ())
     {
+      NS_LOG_DEBUG ("Dropping seqno " << seqno << "; from self"); 
       return true;
     }
   std::map<Mac48Address, uint32_t,std::less<Mac48Address> >::const_iterator i = m_lastDataSeqno.find (source);
@@ -828,6 +838,7 @@
     {
       if ((int32_t)(i->second - seqno)  >= 0)
         {
+          NS_LOG_DEBUG ("Dropping seqno " << seqno << "; stale frame");
           return true;
         }
       m_lastDataSeqno[source] = seqno;
@@ -890,6 +901,9 @@
               receivers_for_interface.push_back (perr.receivers[j].second);
             }
         }
+      Time forwardingDelay = GetMeshPoint ()->GetForwardingDelay ();
+      NS_LOG_DEBUG ("Forwarding PERR with delay " << forwardingDelay.As (Time::US));
+      Simulator::Schedule (forwardingDelay, &HwmpProtocolMac::ForwardPerr, i->second, perr.destinations, receivers_for_interface);
       i->second->ForwardPerr (perr.destinations, receivers_for_interface);
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/model/dot11s/hwmp-protocol.h ns-3.36/src/mesh/model/dot11s/hwmp-protocol.h
--- ns-3.35/src/mesh/model/dot11s/hwmp-protocol.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/model/dot11s/hwmp-protocol.h	2022-04-30 18:23:58.070734500 -0700
@@ -33,6 +33,7 @@
 class Packet;
 class Mac48Address;
 class UniformRandomVariable;
+class RandomVariableStream;
 namespace dot11s {
 class HwmpProtocolMac;
 class HwmpRtable;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/model/dot11s/hwmp-protocol-mac.cc ns-3.36/src/mesh/model/dot11s/hwmp-protocol-mac.cc
--- ns-3.35/src/mesh/model/dot11s/hwmp-protocol-mac.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/model/dot11s/hwmp-protocol-mac.cc	2022-04-30 18:23:58.070734500 -0700
@@ -23,6 +23,7 @@
 #include "ns3/simulator.h"
 #include "ns3/nstime.h"
 #include "ns3/log.h"
+#include "ns3/wifi-mac-header.h"
 #include "dot11s-mac-header.h"
 #include "hwmp-protocol-mac.h"
 #include "hwmp-tag.h"
@@ -89,6 +90,7 @@
   if ((destination == Mac48Address::GetBroadcast ()) && (m_protocol->DropDataFrame (meshHdr.GetMeshSeqno (),
                                                                                     source)))
     {
+      NS_LOG_DEBUG ("Dropping frame; source " << source << " dest " << destination << " seqno " << meshHdr.GetMeshSeqno ()); 
       return false;
     }
   return true;
@@ -228,10 +230,10 @@
   NS_LOG_FUNCTION (this);
   std::vector<IePreq> preq_vector;
   preq_vector.push_back (preq);
-  SendPreq (preq_vector);
+  SendPreqVector (preq_vector);
 }
 void
-HwmpProtocolMac::SendPreq (std::vector<IePreq> preq)
+HwmpProtocolMac::SendPreqVector (std::vector<IePreq> preq)
 {
   NS_LOG_FUNCTION (this);
   Ptr<Packet> packet = Create<Packet> ();
@@ -299,7 +301,7 @@
   //reschedule sending PREQ
   NS_ASSERT (!m_preqTimer.IsRunning ());
   m_preqTimer = Simulator::Schedule (m_protocol->GetPreqMinInterval (), &HwmpProtocolMac::SendMyPreq, this);
-  SendPreq (m_myPreq);
+  SendPreqVector (m_myPreq);
   m_myPreq.clear ();
 }
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/model/dot11s/hwmp-protocol-mac.h ns-3.36/src/mesh/model/dot11s/hwmp-protocol-mac.h
--- ns-3.35/src/mesh/model/dot11s/hwmp-protocol-mac.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/model/dot11s/hwmp-protocol-mac.h	2022-04-30 18:23:58.070734500 -0700
@@ -75,10 +75,10 @@
    */
   void SendPreq (IePreq preq);
   /**
-   * Send PREQ function
+   * Send PREQ function for vector of PREQ
    * \param preq vector of PREQ information elements
    */
-  void SendPreq (std::vector<IePreq> preq);
+  void SendPreqVector (std::vector<IePreq> preq);
   /**
    * Send PREP function
    * \param prep the PREP information element
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/model/dot11s/ie-dot11s-prep.cc ns-3.36/src/mesh/model/dot11s/ie-dot11s-prep.cc
--- ns-3.35/src/mesh/model/dot11s/ie-dot11s-prep.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/model/dot11s/ie-dot11s-prep.cc	2022-04-30 18:23:58.070734500 -0700
@@ -189,7 +189,7 @@
 void
 IePrep::Print (std::ostream& os) const
 {
-  os << "PREP=(Flags=" << m_flags << ", Hopcount=" << m_hopcount << ", TTL=" << m_ttl
+  os << "PREP=(Flags=" << +m_flags << ", Hopcount=" << +m_hopcount << ", TTL=" << m_ttl
      << ",Destination=" << m_destinationAddress << ", Dest. seqnum=" << m_destSeqNumber
      << ", Lifetime=" << m_lifetime << ", Metric=" << m_metric << ", Originator="
      << m_originatorAddress << ", Orig. seqnum=" << m_originatorSeqNumber << ")";
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/model/dot11s/peer-management-protocol-mac.cc ns-3.36/src/mesh/model/dot11s/peer-management-protocol-mac.cc
--- ns-3.35/src/mesh/model/dot11s/peer-management-protocol-mac.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/model/dot11s/peer-management-protocol-mac.cc	2022-04-30 18:23:58.070734500 -0700
@@ -24,6 +24,7 @@
 #include "peer-management-protocol-mac.h"
 #include "peer-management-protocol.h"
 #include "peer-link-frame.h"
+#include "ns3/wifi-mac-queue-item.h"
 #include "ns3/mesh-wifi-interface-mac.h"
 #include "ns3/simulator.h"
 #include "ns3/mesh-information-element-vector.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/model/flame/flame-protocol-mac.cc ns-3.36/src/mesh/model/flame/flame-protocol-mac.cc
--- ns-3.35/src/mesh/model/flame/flame-protocol-mac.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/model/flame/flame-protocol-mac.cc	2022-04-30 18:23:58.070734500 -0700
@@ -21,6 +21,7 @@
 #include "flame-protocol-mac.h"
 #include "flame-protocol.h"
 #include "flame-header.h"
+#include "ns3/wifi-mac-header.h"
 #include "ns3/log.h"
 
 namespace ns3 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/model/mesh-point-device.cc ns-3.36/src/mesh/model/mesh-point-device.cc
--- ns-3.35/src/mesh/model/mesh-point-device.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/model/mesh-point-device.cc	2022-04-30 18:23:58.078734600 -0700
@@ -21,6 +21,8 @@
 
 #include "ns3/packet.h"
 #include "ns3/log.h"
+#include "ns3/simulator.h"
+#include "ns3/string.h"
 #include "ns3/pointer.h"
 #include "ns3/mesh-point-device.h"
 #include "ns3/wifi-net-device.h"
@@ -50,7 +52,12 @@
                     MakePointerAccessor (
                       &MeshPointDevice::GetRoutingProtocol, &MeshPointDevice::SetRoutingProtocol),
                     MakePointerChecker<
-                      MeshL2RoutingProtocol> ());
+                      MeshL2RoutingProtocol> ())
+    .AddAttribute ("ForwardingDelay",
+                   "A random variable to account for processing time (microseconds) to forward a frame.",
+                   StringValue ("ns3::UniformRandomVariable[Min=300.0|Max=400.0]"),
+                   MakePointerAccessor (&MeshPointDevice::m_forwardingRandomVariable),
+                   MakePointerChecker<RandomVariableStream> ());
   return tid;
 }
 
@@ -109,11 +116,12 @@
       if (m_routingProtocol->RemoveRoutingStuff (incomingPort->GetIfIndex (), src48, dst48, packet_copy, realProtocol))
         {
           m_rxCallback (this, packet_copy, realProtocol, src);
-          NS_LOG_DEBUG ("Forwarding from " << src48 << " to " << dst48 << " at " << m_address);
-          Forward (incomingPort, packet, protocol, src48, dst48);
-
           m_rxStats.broadcastData++;
           m_rxStats.broadcastDataBytes += packet->GetSize ();
+          Time forwardingDelay = GetForwardingDelay ();
+          NS_LOG_DEBUG ("Forwarding broadcast from " << src48 << " to " << dst48
+            << " with delay " << forwardingDelay.As (Time::US));
+          Simulator::Schedule (forwardingDelay, &MeshPointDevice::Forward, this, incomingPort, packet, protocol, src48, dst48); 
         }
       return;
     }
@@ -129,7 +137,12 @@
       return;
     }
   else
-    Forward (incomingPort, packet->Copy (), protocol, src48, dst48);
+    {
+      Time forwardingDelay = GetForwardingDelay ();
+      Simulator::Schedule (forwardingDelay, &MeshPointDevice::Forward, this, incomingPort, packet->Copy (), protocol, src48, dst48); 
+      NS_LOG_DEBUG ("Forwarding unicast from " << src48 << " to " << dst48 
+        << " with delay " << forwardingDelay.As (Time::US));
+    }
 }
 
 void
@@ -487,4 +500,18 @@
   m_fwdStats = Statistics ();
 }
 
+int64_t
+MeshPointDevice::AssignStreams (int64_t stream)
+{
+  NS_LOG_FUNCTION (this << stream);
+  m_forwardingRandomVariable->SetStream (stream);
+  return 1;
+}
+
+Time
+MeshPointDevice::GetForwardingDelay () const
+{
+    return MicroSeconds (m_forwardingRandomVariable->GetInteger ());
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/mesh/model/mesh-point-device.h ns-3.36/src/mesh/model/mesh-point-device.h
--- ns-3.35/src/mesh/model/mesh-point-device.h	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/mesh/model/mesh-point-device.h	2022-04-30 18:23:58.078734600 -0700
@@ -27,6 +27,7 @@
 #include "ns3/mac48-address.h"
 #include "ns3/bridge-channel.h"
 #include "ns3/mesh-l2-routing-protocol.h"
+#include "ns3/random-variable-stream.h"
 
 namespace ns3 {
 
@@ -138,6 +139,24 @@
   void ResetStats ();
   ///@}
 
+  /**
+   * Assign a fixed random variable stream number to the random variables
+   * used by this model.  Return the number of streams (possibly zero) that
+   * have been assigned.
+   *
+   * \param stream first stream index to use
+   * \return the number of stream indices assigned by this model
+   */
+  int64_t AssignStreams (int64_t stream);
+
+  /**
+   * Return a (random) forwarding delay value from the random variable
+   * ForwardingDelay attribute.
+   * 
+   * \return A Time value from the ForwardingDelay random variable
+   */
+  Time GetForwardingDelay () const;
+
 private:
   /**
    * Receive packet from interface
@@ -197,6 +216,8 @@
   Ptr<BridgeChannel> m_channel;
   /// Current routing protocol, used mainly by GetRoutingProtocol
   Ptr<MeshL2RoutingProtocol> m_routingProtocol;
+  /// Random variable used for forwarding delay and jitter
+  Ptr<RandomVariableStream> m_forwardingRandomVariable;
 
   /// statistics counters
   struct Statistics
